<cfcomponent displayname="dotnetdemo" output="false">
	

	<cffunction name="getEventLogs" returnType="array" output="false" access="remote" hint="Returns the display names of the system event logs.">
		<cfset var EventLog = createObject('.net', 'System.Diagnostics.EventLog') />
		<cfset var logs = EventLog.getEventLogs() />
		<cfset var i = 1 />
		<cfset var result = arrayNew(2) />
		<cfloop from="1" to="#arrayLen(logs)#" index="i">
			<cfset result[i][1] = logs[i].get_Log() />
			<cfset result[i][2] = logs[i].get_LogDisplayName() />
		</cfloop>
		<cfreturn result />
	</cffunction>

    <cffunction name="GetEventLog" returntype="query" output="false" access="public" hint="Retreives the specified event log.">
        <cfargument name="log" type="string" default="" required="true" hint="Name of the event log to retrieve." />
        <cfset var entry = '' />
        <cfset var total = 0 />
        <cfset var i = 0 />
        <cfset var result = queryNew("type,eventid,source,generated,message",
                                     "varchar,integer,varchar,date,varchar") />
		<cfset var entries = '' />
		<cfset var EventLog = createObject('.net', 'System.Diagnostics.EventLog') />
		<cftry>
		<cfscript>
			// set log type
			EventLog.set_Log(ARGUMENTS.log);
			// get log entries
			entries = EventLog.get_Entries();
			total = entries.get_Count() - 500; // reverse loop over the index with 500 padding to skip blank entries
			// popluate query
			for(i = total; i > total - 50; i = i - 2) // limiting total returned for speed
			{
				entry = entries.get_Item(javaCast('int', i));
				// add record to result query
				queryAddRow(result);
				querySetCell(result, "type", entry.Get_EntryType().ToString());
				querySetCell(result, "eventid", entry.Get_EventID());
				querySetCell(result, "source", entry.Get_Source());
				querySetCell(result, "generated", entry.Get_TimeGenerated().ToString());
				querySetCell(result, "message", entry.Get_Message());
			}
		</cfscript>
			<cfcatch type="any" />
		</cftry>
        <!---- return success ---->
        <cfreturn result />
    </cffunction>
	
	<cffunction name="getEventLog_cfgrid" output="false" access="remote" returntype="Any">
		<cfargument name="log" type="string" default="" required="true" hint="Name of the event log to retrieve." />
		<cfargument name="keyword" type="string" required="true" default="" />
		<cfargument name="page" type="numeric" required="true" />
		<cfargument name="pageSize" type="numeric" required="true" />
		<cfargument name="sortCol" type="string" required="true" />
		<cfargument name="sortDir" type="string" required="true" />
		<cfset var result = getEventLog(ARGUMENTS.log) />
        <!---- sort query ---->
        <cfquery dbtype="query" name="result">
        	SELECT * FROM result
			<cfif len(ARGUMENTS.keyword)>
			WHERE source LIKE '%#ARGUMENTS.keyword#%'
			</cfif>
			<cfif len(ARGUMENTS.sortCol)>
            ORDER BY #ARGUMENTS.sortCol# <cfif len(ARGUMENTS.sortDir)>#ARGUMENTS.sortDir#</cfif>
            </cfif>
        </cfquery>
        <!----  return success ---->
        <cfreturn queryConvertForGrid(result, ARGUMENTS.page, ARGUMENTS.pageSize) />
	</cffunction>
    
	<!----
    <cffunction name="GetDriveInfo" returntype="query" output="false" access="public" hint="Returns information about sytem disks.">
        <cfargument name="drive" type="string" required="no" default="" hint="Drive letter or name of system disk to retrieve information." />
        
        <cfset var result = queryNew("name,type,isReady,format,label,totalsize,freespace",
                                    "varchar,varchar,bit,varchar,varchar,double,double") />
        <cfset var DriveInfo = createObject('.net', 'System.IO.DriveInfo') />
        <cfset var drives = DriveInfo.getDrives() />
        <cfset var i = 0 />
        
        <cfscript>
            // loop through drives
            for(i = 1; i <= arrayLen(drives); i++)
            {
                if	(
                        ARGUMENTS.drive == '' || // if no drive specified get all
                        ARGUMENTS.drive == drives[i].get_name() || // if matches disk name
                        (len(ARGUMENTS.drive) == 1 && ARGUMENTS.drive == left(drives[i].get_name(), 1)) // if matches disk letter
                    )
                {
                    // add new row to result query
                    queryAddRow(result);
                    // get core details
                    querySetCell(result, 'name', drives[i].get_name());
                    querySetCell(result, 'type', drives[i].get_driveType().toString());
                    querySetCell(result, 'isReady', drives[i].get_isReady());
                    // get extended details if drive is ready
                    if(drives[i].get_isReady())
                    {
                        querySetCell(result, "format", drives[i].Get_DriveFormat());
                        querySetCell(result, "label", drives[i].Get_VolumeLabel());
                        querySetCell(result, "totalsize", drives[i].Get_TotalSize());
                        querySetCell(result, "freespace", drives[i].Get_AvailableFreeSpace());
                    }
                    
                }
            }
        </cfscript>
        <!---- return success ---->
        <cfreturn result />
	</cffunction>
	---->
	
</cfcomponent>